> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tight.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Save cars

> Save new (or update existing) cars



## OpenAPI

````yaml https://dev.tight.com/v3/api-docs post /v6/mileage/cars
openapi: 3.0.1
info:
  title: Tight API
  contact:
    name: Hurdlr, Inc. (dba Tight)
    url: https://www.tight.com
    email: api@tight.com
  version: 6.0.0
servers:
  - url: https://sandbox.tight.com
    description: Staging Environment
  - url: https://prod.tight.com
    description: Production Environment
security:
  - EmbedToken: []
paths:
  /v6/mileage/cars:
    post:
      tags:
        - Mileage Cars
      summary: Save cars
      description: Save new (or update existing) cars
      operationId: postCars
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MultiParamCarPostDto'
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseCarGetDto'
        '207':
          description: Some cars failed to save. See response body for error details.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseCarGetDto'
        '400':
          description: All cars failed to save.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseCarGetDto'
        '401':
          description: Not authenticated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: INVALID_TOKEN
                    message: Invalid access token
        '403':
          description: Not authorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: FORBIDDEN
                    message: Expired access token
        '404':
          description: Endpoint not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: BAD_REQUEST
                    message: Resource not found
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: UNKNOWN_ERROR
                    message: Something went wrong. Please try again later.
      security:
        - EmbedToken: []
components:
  schemas:
    MultiParamCarPostDto:
      required:
        - data
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/CarPostDto'
    ResponseListMultiResponseCarGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: array
          description: The data generated by the action performed.
          items:
            $ref: '#/components/schemas/MultiResponseCarGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    ErrorResponse:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: object
          description: The data generated by the action performed.
          nullable: true
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    CarPostDto:
      type: object
      properties:
        id:
          type: string
          description: Id of the car, required when updating an existing car
          example: car_28868401
        make:
          type: string
          description: Make of the car
          nullable: false
          example: Toyota
        model:
          type: string
          description: Model of the car
          nullable: false
          example: Camry
        name:
          type: string
          description: Name of the car
          nullable: false
          example: My Toyota Camry
        year:
          type: integer
          description: Year of the car's make
          format: int32
          nullable: false
          example: 2022
        isPrimary:
          type: boolean
          description: Whether this car is the user's primary car
          nullable: false
          example: true
        status:
          type: string
          description: Status of the car
          nullable: false
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        details:
          type: array
          nullable: true
          items:
            type: object
            properties:
              year:
                type: integer
                description: Year associated with this detail
                format: int32
                example: 2024
              odometer:
                type: integer
                description: >-
                  Odometer reading from the beginning of the year associated
                  with this detail
                format: int32
                example: 12500
        customData:
          $ref: '#/components/schemas/JsonNode'
    MultiResponseCarGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        statusCode:
          $ref: '#/components/schemas/HttpStatus'
        data:
          $ref: '#/components/schemas/CarGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
      description: The data generated by the action performed.
    ErrorItem:
      type: object
      properties:
        type:
          type: string
          description: The type of the error. Safe for programmatic use.
          enum:
            - UNKNOWN_ERROR
            - INVALID_TOKEN
            - EXPIRED_TOKEN
            - FORBIDDEN
            - BAD_REQUEST
            - JSON_ERROR
            - DUPLICATE
            - REQUIRED
            - INVALID_VALUE
            - NOT_MODIFIABLE
            - INVALID_FORMAT
            - NOT_FOUND
        message:
          type: string
          description: >-
            A human-readable message providing more details about the error.
            Safe for displaying to a user.
        param:
          type: string
          description: >-
            If the error is parameter-specific, the parameter related to the
            error. This can be used to display a message near the correct form
            field.
      description: Errors associated with the action performed, if applicable.
    JsonNode:
      type: object
      properties:
        empty:
          type: boolean
        array:
          type: boolean
        'null':
          type: boolean
        object:
          type: boolean
        float:
          type: boolean
        string:
          type: boolean
        number:
          type: boolean
        missingNode:
          type: boolean
        valueNode:
          type: boolean
        nodeType:
          type: string
          enum:
            - ARRAY
            - BINARY
            - BOOLEAN
            - MISSING
            - 'NULL'
            - NUMBER
            - OBJECT
            - POJO
            - STRING
        pojo:
          type: boolean
        integralNumber:
          type: boolean
        floatingPointNumber:
          type: boolean
        short:
          type: boolean
        int:
          type: boolean
        long:
          type: boolean
        double:
          type: boolean
        bigDecimal:
          type: boolean
        bigInteger:
          type: boolean
        textual:
          type: boolean
          deprecated: true
        boolean:
          type: boolean
        binary:
          type: boolean
        container:
          type: boolean
        embeddedValue:
          type: boolean
      description: >-
        Custom JSON in which you can store any data with max length of 2000
        characters
      nullable: true
      example:
        internal_key: some_internal_key
        some_other_field: 23434
    HttpStatus:
      type: integer
      description: The HTTP status code for the action performed.
      format: int32
      enum:
        - 200
        - 400
        - 401
        - 403
        - 404
        - 500
    CarGetDto:
      required:
        - details
        - id
        - isPrimary
        - make
        - model
        - name
        - status
        - year
      type: object
      properties:
        id:
          type: string
          description: Id of the car
          example: car_28868401
        make:
          type: string
          description: Make of the car
          nullable: true
          example: Toyota
        model:
          type: string
          description: Model of the car
          nullable: true
          example: Camry
        name:
          type: string
          description: Name of the car
          nullable: true
          example: My Toyota Camry
        year:
          type: integer
          description: Year of the car's make
          format: int32
          nullable: true
          example: 2022
        isPrimary:
          type: boolean
          description: Whether this car is the user's primary car
          example: true
        status:
          type: string
          description: Status of the car
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        details:
          type: array
          items:
            $ref: '#/components/schemas/CarDetailGetDto'
        customData:
          $ref: '#/components/schemas/JsonNode'
      description: The data generated by the action performed.
    CarDetailGetDto:
      required:
        - odometer
        - year
      type: object
      properties:
        year:
          type: integer
          description: Year associated with this detail
          format: int32
          example: 2024
        odometer:
          type: integer
          description: >-
            Odometer reading from the beginning of the year associated with this
            detail
          format: int32
          example: 12500
      description: Yearly detail entries for this car
      nullable: true
  securitySchemes:
    EmbedToken:
      type: http
      description: >-
        Bearer authentication header of the form `Bearer <token>`, see
        [Authentication for more
        detail](/api-reference/authentication#partner-level-authentication).
      scheme: bearer

````